-- Variables that are used on both client and server 
  
AddCSLuaFile( "shared.lua" ) --tells the client that, if they dont have this EXACT file (in this EXACT file structure) to download
  
SWEP.Author   = "Garry (edit by Soild_Jake, Further edit by FunnyGamer)" --sets the author pop-up text
SWEP.Instructions      = "left: smg fire; right: linar fire" --sets the instructions popup text (you know, the stuff that no one really READS)
  
SWEP.Spawnable      = false --no one can spawn this...
SWEP.AdminSpawnable  = true --...except admin(s)!!!!
  
SWEP.ViewModel      = "models/weapons/v_smg1.mdl" --sets the view model (the one you see) to the smg model
SWEP.WorldModel     = "models/weapons/w_smg1.mdl" --sets the world model (the one that others [and you if you see it is on the ground] can see) to the smg model
  
  -- you know those newbie sweps that dont have infinite ammo, but rather have like, twenty nines for clip and extra ammo? Setting these numerical values to -1 makes them infinite!
SWEP.Primary.ClipSize      = -1 --makes the clip infinitly sized
SWEP.Primary.DefaultClip    = -1 --sets no extra ammo
SWEP.Primary.Automatic    = true --automatic primary
SWEP.Primary.Ammo         = "450" -- I have NO freakin' idea
  
SWEP.Secondary.ClipSize  = -1 --see last clipsize comment
SWEP.Secondary.DefaultClip  = -1 --see last defaultclip comment
SWEP.Secondary.Automatic    = true --automatic secondary
SWEP.Secondary.Ammo   = "45" --I have NO freakin' idea
  
SWEP.Weight    = 5 --set this high enough, it will sink it water. if an npc has it (which is unlikely), this determins how it acts when the gun is dropped (more weight means faster fall, right?)
SWEP.AutoSwitchTo      = false --dont switch to it when you pick it up
SWEP.AutoSwitchFrom  = false --dont switch away from it when you pick something else up
  
SWEP.PrintName      = "Uber Flechette smg" --sets the name of the swep            
SWEP.Slot            = 1 -- which slot is it used in. 1 because no one puts stuff there (NEVER put things in slot 6. people get angry)
SWEP.SlotPos            = 5 --sets how far down the list the weapon is. try not to overlap two weapons
SWEP.DrawAmmo         = true -- draws the used bullets being thrown out? (I think so because with draw crosshair off, there is no crosshair to help you aim)
SWEP.DrawCrosshair    = true -- makes the crosshair (or aiming reticule, if your weird)
  
  
local ShootSound = Sound( "NPC_Hunter.FlechetteShoot" ) --tells the game too index this as a local sound under the name of "shootsound"
  
/*--------------------------------------------------------- 
    --Reload does nothing 
---------------------------------------------------------
function SWEP:Reload() 
  
end 
  
--------------------------------------------------------- --commented out, because less thinks means less lag(s?). If you feel like giving the weapon something to think about, uncomment certain things.
   --Think does nothing 
---------------------------------------------------------
function SWEP:Think()     
end 
  
  
--------------------------------------------------------- 
   --PrimaryAttack 
---------------------------------------------------------*/ 
function SWEP:PrimaryAttack() 
  
    self.Weapon:SetNextPrimaryFire( CurTime() + 0.1 ) --sets the pace at the automatic/clicking like mad fire rate
    self.Weapon:SendWeaponAnim( ACT_VM_PRIMARYATTACK ) --plays the view model's primary attack animation. essential to make things look cooler
    self:EmitSound( ShootSound ) --plays our indexed sound
    self:ShootEffects( self ) --????
    
    -- The rest is only done on the server 
    if (!SERVER) then return end --runs the following on the server
    
        local r1 = math.random(-500, 500) / 10000 --scaters the flechettes, making it a true smg
        local r2 = math.random(-500, 500) / 10000 --see last
        local r3 = math.random(-500, 500) / 10000 --see last's last
        local Forward = self.Owner:EyeAngles():Forward() + Angle(r1, r2, r3) /* a little complex. basically, this determins the angles of the shot, 	
		as "forward". "Forward" is defined by our aim position and our rotation (I think), and the r's (r1, r2, and r3, which are classified as angles (see "Angle") instead of aim
		messer-uppers*/

    local ent = ents.Create( "hunter_flechette" ) //indexes the flechette as ent
    if ( ValidEntity( ent ) ) then --checks if ent is real. if it is, this runs
    
            ent:SetPos( self.Owner:GetShootPos() + Forward * 32 ) --do not change or this will be screwed up the butthole
            ent:SetAngles( self.Owner:EyeAngles() ) --sets our ent's angles to our eye's angles
        ent:Spawn() --makes the flechette
        Forward = Forward*math.Rand(1,2) --see 2 comments above
        ent:SetVelocity( Forward * 2000 ) --see last. DO NOT CHANGE! LOOKS LIKE SPEED, BUT IT IS WHERE THE FLECHETTE COMES OUT OF THE PLAYER!
        
    end 
    
    ent:SetOwner( self.Owner ) --gives you the kill, not that kill stealin' bastard known as #entinty_flechette
    
end 
  
--------------------------------------------------------- 
    --SecondaryAttack 
---------------------------------------------------------*/ 
function SWEP:SecondaryAttack() 
  
    -- Right click does nothing.. 
    self.Weapon:SetNextPrimaryFire( CurTime() + 0.25 ) 
    self:EmitSound( ShootSound ) 
    self:ShootEffects( self ) 
    
    -- The rest is only done on the server 
    if (!SERVER) then return end --runs the functions on the server
    
    local Forward = self.Owner:EyeAngles():Forward() --gets the direction we are aiming
    
    local ent = ents.Create( "hunter_flechette" )  --indexes the flechette as "ent" for later use
    if ( ValidEntity( ent ) ) then --checks if there is such thing as "ent" (see last comment). If it is, it runs the following functions
    
            ent:SetPos( self.Owner:GetShootPos() + Forward * 32 ) --this is perfect, sets the flechette's RIGHT IN THE AIMING RETICULE. do not change this, or else it will be f****d up
            ent:SetAngles( self.Owner:EyeAngles() ) -- sets the angle of the flechette to our aiming angle
        ent:Spawn() -- creates the ent. I am still trying to figure out how to make more than one ent at a time. both multiplication and multiple ent:spawn()'s don't work. maybe some ent:Spawn(6)'s...
        Forward = Forward*math.Rand(1,2) --this is also perfect, sets the flechette's RIGHT IN THE AIMING RETICULE. do not change this, or else it will be f****d up, too
        ent:SetVelocity( Forward * 2000 ) --see last comment
        
    end 
    
    ent:SetOwner( self.Owner )  --makes it so the kill is yours, not the #entity_flechette
end 
  
  
--------------------------------------------------------- 
   --Name: ShouldDropOnDie 
   --Desc: Should this weapon be dropped when its owner dies? 
---------------------------------------------------------*/ 
function SWEP:ShouldDropOnDie() 
    return false 
end 